/* GNU polyxmass - the massist's program.
   -------------------------------------- 
   Copyright (C) 2000,2001,2002 Filippo Rusconi

   http://www.polyxmass.org

   This file is part of the "GNU polyxmass" project.
   
   The "GNU polyxmass" project is an official GNU project package (see
   www.gnu.org) released ---in its entirety--- under the GNU General
   Public License and was started at the Centre National de la
   Recherche Scientifique (FRANCE), that granted me the formal
   authorization to publish it under this Free Software License.

   This software is free software; you can redistribute it and/or
   modify it under the terms of the GNU  General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This software is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.
   
   You should have received a copy of the GNU  General Public
   License along with this software; if not, write to the
   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.
*/

#ifndef PXMUTILS_GLOBALS_H
#define PXMUTILS_GLOBALS_H

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

/*
#define _(String) (String)
#define N_(String) String
#define textdomain(GETTEXT_PACKAGE)
#define bindtextdomain(GETTEXT_PACKAGE, LOCALEDIR)
*/

/* When ready for the gettext step, change lines above with:
 */
// #include <libintl.h>  replace with the wrapper ENABLE_NLS depending one:
#include "gettext.h" // see gettext manual page 111.
#define _(String) gettext (String) 
#define gettext_noop(String) String 
#define N_(String) gettext_noop (String)
/*
 */

#define debug_printf( x ) \
{ \
  printf ( "%s @ %u : ", __FILE__, __LINE__ ); \
  printf x; \
  fflush ( stdout ); \
}

/* all the includes */
#include <glib.h>
#include <math.h>
#include <stddef.h>
#include <limits.h>
#include <errno.h>
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <dirent.h>
#include <time.h>
#include <stdlib.h>
#include <locale.h>

#include <libxml/xmlmemory.h>
#include <libxml/parser.h>
#include <libxml/tree.h>


/********************** GENERALLY UNIVERSAL DEFINES **********************/
#define MAX_LINE_LENGTH 1000
#define MAX_ATOM_SYMBOL_LEN 2


enum 
{
  ODD, 
  EVEN,
  ALL
};


/* ************************** GLIB IMPORTS ***************************
 * these data have been imported from the glib (garray.c) in order 
 * to be able to write a function that was not available at the time
 * of this writing : the function g_ptr_array_insert_val () below.
 */
/* #define imported from glib with no change
 */
#define MIN_ARRAY_SIZE  16

/* typedef imported with no change
 */
typedef struct _GRealPtrArray  GRealPtrArray;

/* struct definition imported with no change
 */
struct _GRealPtrArray
{
  gpointer *pdata;
  guint     len;
  guint     alloc;
};


void 
g_ptr_array_maybe_expand (GRealPtrArray *array, gint len);

gint 
g_nearest_pow (gint num);

/* this one I had to write myself because it did not exist in the glib
 * Returns: a pointer to the data after insertion at 'index'.
 */
gpointer 
g_ptr_array_insert_val (GPtrArray * farray, guint index,
			gpointer data);
/* *********************** END OF GLIB IMPORTS ************************
 */




/* STRING MANIPULATION FUNCTIONS
 */
gchar * 
pxmutils_globals_unspacify_string (gchar **str);



/* XML-format TRANSACTIONS
 */
gchar*
pxmutils_globals_format_string_lead (gchar *indent, gint offset);


gboolean
pxmutils_globals_check_xml_file (gchar *file);


/* HELPER FUNCTIONS
 */



/* FILE COPYING UTILITIES
 */
gboolean 
pxmutils_globals_copy_files (gchar *dest, gchar *src);





/* NUMERICAL <--> STRING conversions.
 */
gboolean
pxmutils_globals_strtod (gchar *str, gdouble *val);


gboolean
pxmutils_globals_strtoi (gchar *str, gint *val, gint base);


gchar *
pxmutils_globals_dtoa (gdouble val, gint prec);




gint 
pxmutils_globals_fill_int_array_match_exp (gchar *exp, GArray *GA,
					   gint max);

gint
pxmutils_globals_match_int_subexp (gchar *exp, GArray *GA, gint max);

gint
pxmutils_globals_match_int_single_value_subexp (gchar * exp, 
						GArray *GA, gint max);

gint
pxmutils_globals_match_int_bracketted_dashed_values_subexp (gchar * exp, 
							    GArray *GA, 
							    gint max);

gint
pxmutils_globals_match_int_all_subexp (GArray *GA, 
				       gint max);

gint
pxmutils_globals_match_int_even_subexp (GArray *GA, 
					gint max);

gint
pxmutils_globals_match_int_odd_subexp (GArray *GA, 
				       gint max);




#ifdef __cplusplus
}
#endif /* __cplusplus */


#endif /* ifndef PXMUTILS_GLOBALS_H */

