/* GNU polyxmass - the massist's program.
   -------------------------------------- 
   Copyright (C) 2000,2001,2002 Filippo Rusconi

   http://www.polyxmass.org

   This file is part of the "GNU polyxmass" project.
   
   The "GNU polyxmass" project is an official GNU project package (see
   www.gnu.org) released ---in its entirety--- under the GNU General
   Public License and was started at the Centre National de la
   Recherche Scientifique (FRANCE), that granted me the formal
   authorization to publish it under this Free Software License.

   This software is free software; you can redistribute it and/or
   modify it under the terms of the GNU  General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This software is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.
   
   You should have received a copy of the GNU  General Public
   License along with this software; if not, write to the
   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.
*/

#ifndef PXMUTILS_PROP_H
#define PXMUTILS_PROP_H


#include "pxmutils-globals.h"

typedef struct _PxmProp PxmProp;


enum
{
  PROP_NAME,
  PROP_DATA,
  PROP_BOTH
};


struct _PxmProp
{
  gchar *name;
  
  gpointer data;
  
  PxmProp *(*custom_dup) (PxmProp * prop);
  
  gint (*custom_cmp) (gint what, 
		      PxmProp * prop1, PxmProp * prop2);
  
  gint (*custom_free) (PxmProp * prop);
  
};

/* HELPER FUNCTIONS
 */







/* NEW'ING FUNCTIONS, DUPLICATING FUNCTIONS ...
 */
PxmProp*
pxmutils_prop_new (void);

PxmProp *
pxmutils_prop_dup (PxmProp *prop);

PxmProp *
pxmutils_prop_both_strings_new (gchar *name, gchar *data);

PxmProp *
pxmutils_prop_dflt_prop_dup (PxmProp *prop);


/* DATA MODIFYING FUNCTIONS
 */
gchar *
pxmutils_prop_set_name (PxmProp *prop, gchar *name);



/* COMPARISON FUNCTIONS
 */
gint
pxmutils_prop_cmp (gint what, PxmProp *prop1, PxmProp *prop2);

gint
pxmutils_prop_dflt_prop_cmp (gint what, 
			PxmProp *prop1, PxmProp *prop2);

gint 
pxmutils_prop_gpointer_data_prop_cmp (gint what, 
				 PxmProp *prop1, PxmProp *prop2);


/* RENDERING FUNCTIONS - FORMATTER FUNCTIONS
 */
gchar *
pxmutils_prop_format_xml_prop_default (PxmProp *prop,
				       gchar *indent,
				       gint offset,
				       gpointer user_data);


PxmProp *
pxmutils_prop_render_xml_prop_default (xmlDocPtr xml_doc,
				       xmlNodePtr xml_node,
				       gpointer user_data);






/* FREE'ING FUNCTIONS
 */
gint 
pxmutils_prop_free (PxmProp *prop);

gint 
pxmutils_prop_dflt_prop_free (PxmProp *prop);

gint 
pxmutils_prop_free_but_not_data (PxmProp *prop);



/* GPtrArray of prop pointers-related functions
 */
PxmProp * 
pxmutils_prop_find_prop (GPtrArray * p_GPA,
			 gint *p_idx,
			 gint (* pxmutils_prop_data_cmp_func) (),
			 gchar *name,
			 gpointer data);

GPtrArray *
pxmutils_prop_GPA_dup (GPtrArray *p_GPA);

gint 
pxmutils_prop_GPA_copy (GPtrArray *destGPA, GPtrArray *srcGPA);

gint 
pxmutils_prop_GPA_free (GPtrArray *p_GPA);





#endif






