/* GNU polyxmass - the massist's program.
   -------------------------------------- 
   Copyright (C) 2000,2001,2002 Filippo Rusconi

   http://www.polyxmass.org

   This file is part of the "GNU polyxmass" project.
   
   The "GNU polyxmass" project is an official GNU project package (see
   www.gnu.org) released ---in its entirety--- under the GNU General
   Public License and was started at the Centre National de la
   Recherche Scientifique (FRANCE), that granted me the formal
   authorization to publish it under this Free Software License.

   This software is free software; you can redistribute it and/or
   modify it under the terms of the GNU  General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This software is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.
   
   You should have received a copy of the GNU  General Public
   License along with this software; if not, write to the
   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.
*/

#ifndef PXMUTILS_USERSPEC_H
#define PXMUTILS_USERSPEC_H


#include "pxmutils-globals.h"


typedef struct _PxmUserspec PxmUserspec;


struct _PxmUserspec
{
  gchar *username;
  gchar *configdir;
  gchar *gladedir;
  gchar *workdir;
  gchar *datadir;

  /* The traditional array of prop objects.
   */
  GPtrArray *propGPA;
};
  


/* NEW'ING FUNCTIONS, DUPLICATING FUNCTIONS ...
 */

PxmUserspec *
pxmutils_userspec_new (void);

PxmUserspec *
pxmutils_userspec_dup_no_prop (PxmUserspec *userspec);

PxmUserspec *
pxmutils_userspec_dup (PxmUserspec *userspec);

gboolean
pxmutils_userspec_set_username (PxmUserspec *userspec, gchar *username);

gchar *
pxmutils_userspec_get_username (PxmUserspec *userspec);

gboolean
pxmutils_userspec_set_configdir (PxmUserspec *userspec, gchar *dir);

gchar *
pxmutils_userspec_get_configdir (PxmUserspec *userspec);

gboolean
pxmutils_userspec_set_gladedir (PxmUserspec *userspec, gchar *dir);

gchar *
pxmutils_userspec_get_gladedir (PxmUserspec *userspec);

gboolean
pxmutils_userspec_set_workdir (PxmUserspec *userspec, gchar *dir);

gchar *
pxmutils_userspec_get_workdir (PxmUserspec *userspec);

gboolean
pxmutils_userspec_set_datadir (PxmUserspec *userspec, gchar *dir);

gchar *
pxmutils_userspec_get_datadir (PxmUserspec *userspec);



/* UTILITY FUNCTIONS
 */






/* FREE'ING FUNCTIONS
 */
gboolean
pxmutils_userspec_free (PxmUserspec *userspec);















#endif





